package RTC;


/**
* RTC/MultiModeComponentActionOperations.java .
* IDL-to-Java \u30b3\u30f3\u30d1\u30a4\u30e9 (\u30dd\u30fc\u30bf\u30d6\u30eb), \u30d0\u30fc\u30b8\u30e7\u30f3 "3.1" \u3067\u751f\u6210
* \u751f\u6210\u5143: idl/LogicalTimeTriggeredEC.idl
* 2015\u5e743\u670820\u65e5 14\u664235\u520651\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief MultiModeComponentAction
   *
   * MultiModeComponentAction is a companion to ComponentAction that
   is realized by RTCs that support multiple modes.
   *
   * @endif
   */
public interface MultiModeComponentActionOperations 
{

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_mode_changed
       *
       * @section Description
       *
       * This callback is invoked each time the observed mode of a
       * component has changed with respect to a particular execution
       * context.
       *
       * @section Semantics
       *
       * If the context is PERIODIC, this callback shall come before the
       * next call to on_execute (see Section 5.3.1.2.1) within that
       * context.  The new mode can be retrieved with
       * get_current_mode_in_context. If the result is the same as the
       * result of get_current_mode, the mode has stabilized.
       *
       * @endif
       */
  RTC.ReturnCode_t on_mode_changed (int exec_handle);
} // interface MultiModeComponentActionOperations
