package RTC;


/**
* RTC/_FsmObjectStub.java .
* IDL-to-Java \u30b3\u30f3\u30d1\u30a4\u30e9 (\u30dd\u30fc\u30bf\u30d6\u30eb), \u30d0\u30fc\u30b8\u30e7\u30f3 "3.1" \u3067\u751f\u6210
* \u751f\u6210\u5143: idl/LogicalTimeTriggeredEC.idl
* 2015\u5e743\u670820\u65e5 14\u664235\u520651\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief FsmObject
   *
   * @section Description
   *
   * The FsmObject interface allows programs to send stimuli to a
   * finite state machine, possibly causing it to change states.
   *
   * @endif
   */
public class _FsmObjectStub extends org.omg.CORBA.portable.ObjectImpl implements RTC.FsmObject
{


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief send_stimulus
       *
       * @section Description
       *
       * Send a stimulus to an FSM that realizes this interface.
       *
       * @section Semantics
       *
       * If the stimulus corresponds to any outgoing transition of the
       * current state, that transition shall be taken and the state
       * shall change. Any FSM participants associated with the exit of
       * the current state, the transition to the new state, or the
       * entry to the new state shall be invoked. If the stimulus does
       * not correspond to any such transition, this operation shall
       * succeed but have no effect.  
       *
       * If the given execution context is a non-nil reference to a
       * context in which this FSM participates, the transition shall be
       * executed in that context. If the argument is nil, the FSM shall
       * choose an EVENT_DRIVEN context in which to execute the
       * transition. If the argument is non-nil, but this FSM does not
       * participate in the given context, this operation shall fail
       * with * ReturnCode_t::BAD_PARAMETER.
       *
       * @section Constraints
       *
       * - The given execution context shall be of kind EVENT_DRIVEN.
       *
       * @endif
       */
  public RTC.ReturnCode_t send_stimulus (String message, int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("send_stimulus", true);
                $out.write_string (message);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return send_stimulus (message, exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // send_stimulus

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:omg.org/RTC/FsmObject:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _FsmObjectStub
