package RTC;


/**
* RTC/_RTObjectStub.java .
* IDL-to-Java \u30b3\u30f3\u30d1\u30a4\u30e9 (\u30dd\u30fc\u30bf\u30d6\u30eb), \u30d0\u30fc\u30b8\u30e7\u30f3 "3.1" \u3067\u751f\u6210
* \u751f\u6210\u5143: idl/LogicalTimeTriggeredEC.idl
* 2015\u5e743\u670820\u65e5 14\u664235\u520651\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief RTObject
   *
   * @section Description
   *
   * The RTObject interface defines the operations that all SDO-based
   * RTCs must provide. It is required by the rtComponent stereotype.
   *
   * @endif
   */
public class _RTObjectStub extends org.omg.CORBA.portable.ObjectImpl implements RTC.RTObject
{


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief get_component_profile
       *
       * @section Description
       *
       * This operation returns the ComponentProfile of the RTC.
       *
       * @endif
       */
  public RTC.ComponentProfile get_component_profile ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_component_profile", true);
                $in = _invoke ($out);
                RTC.ComponentProfile $result = RTC.ComponentProfileHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_component_profile (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_component_profile


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief get_ports
       *
       * @section Description
       *
       * This operation returns a list of the RTCs ports.
       *
       * @endif
       */
  public RTC.PortService[] get_ports ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_ports", true);
                $in = _invoke ($out);
                RTC.PortService $result[] = RTC.PortServiceListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_ports (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_ports


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief initialize
       *
       * @section Description
       * Initialize the RTC that realizes this interface.
       *
       * @section Semantics
       * The invocation of this operation shall result in the invocation
       * of the callback ComponentAction::on_initialize.
       *
       * @section Constraints
       *
       * - An RTC may be initialized only while it is in the Created
       *   state. Any attempt to invoke this operation while in another
       *   state shall fail with ReturnCode_t::PRECONDITION_NOT_MET.
       * - Application developers are not expected to call this operation
       *   directly; it exists for use by the RTC infrastructure.
       *
       * @endif
       */
  public RTC.ReturnCode_t initialize ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("initialize", true);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return initialize (        );
            } finally {
                _releaseReply ($in);
            }
  } // initialize


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief finalize
       *
       * @section Description
       *
       * Finalize the RTC that realizes this interface, preparing it for
       * destruction.
       *
       * @section Semantics
       *
       * This invocation of this operation shall result in the
       * invocation of the callback ComponentAction::on_finalize
       *
       * @section Constraints
       *
       * - An RTC may not be finalized while it is participating in any
       *   execution context. It must first be removed with
       *   ExecutionContextOperations::remove_component. Otherwise, this
       *   operation shall fail with
       *   ReturnCode_t::PRECONDITION_NOT_MET. See Figure 5.9.
       *
       * - An RTC may not be finalized while it is in the Created state. Any
       *   attempt to invoke this operation while in that state shall fail with
       *   ReturnCode_t::PRECONDITION_NOT_MET.
       *
       * - Application developers are not expected to call this operation
       *   directly; it exists for use by the RTC infrastructure.
       *
       * @endif
       */
  public RTC.ReturnCode_t _finalize ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("finalize", true);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return _finalize (        );
            } finally {
                _releaseReply ($in);
            }
  } // _finalize


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief is_alive
       * 
       * @section Description
       *
       * A component is alive or not regardless of the execution context
       * from which it is observed. However, whether or not it is
       * Active, Inactive, or in Error is dependent on the execution
       * context(s) (see Figure 5.7) in which it is running. That is, it
       * may be Active in one context but Inactive in
       * another. Therefore, this operation shall report whether this
       * RTC is either Active, Inactive, or in Error; which of those
       * states a component is in with respect to a particular context
       * may be queried from the context itself.
       *
       * @endif
       *
       */
  public boolean is_alive (RTC.ExecutionContext exec_context)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("is_alive", true);
                RTC.ExecutionContextHelper.write ($out, exec_context);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return is_alive (exec_context        );
            } finally {
                _releaseReply ($in);
            }
  } // is_alive


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief exit
       *
       * @section Description
       *
       * Stop the RTC\u00fdfs execution context(s) and finalize it along with
       * its contents.
       *
       * @section Semantics
       *
       * Any execution contexts for which the RTC is the owner shall be
       * stopped.  If the RTC participates in any execution contexts
       * belonging to another RTC that contains it, directly or
       * indirectly (i.e., the containing RTC is the owner of the
       * ExecutionContext), it shall be deactivated in those contexts.
       * After the RTC is no longer Active in any Running execution
       * context, it and any RTCs contained transitively within it shall
       * be finalized.
       *
       * @section Constraints
       *
       * An RTC cannot be exited if it has not yet been initialized. Any
       * attempt to exit an RTC that is in the Created state shall fail
       * with ReturnCode_t::PRECONDITION_NOT_MET.  
       *
       * @endif
       */
  public RTC.ReturnCode_t exit ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("exit", true);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return exit (        );
            } finally {
                _releaseReply ($in);
            }
  } // exit


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief attach_context
       *
       * @section Description
       *
       * Inform this RTC that it is participating in the given execution
       * context. Return a handle that represents the association of
       * this RTC with the context.
       *
       * @section Semantics
       *
       * This operation is intended to be invoked by
       * ExecutionContextOperations::add_component (see Section
       * 5.2.2.6.6). It is not intended for use by other clients.
       *
       * @endif
       */
  public int attach_context (RTC.ExecutionContext exec_context)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("attach_context", true);
                RTC.ExecutionContextHelper.write ($out, exec_context);
                $in = _invoke ($out);
                int $result = RTC.ExecutionContextHandle_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return attach_context (exec_context        );
            } finally {
                _releaseReply ($in);
            }
  } // attach_context


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief detach_context
       * @section Description
       * 
       * Inform this RTC that it is no longer participating in the given
       * execution context.
       *
       * @section Semantics
       * 
       * This operation is intended to be invoked by
       * ExecutionContextOperations::remove_component (see Section
       * 5.2.2.6.7). It is not intended for use by other clients.
       *
       * @section Constraints
       *
       * - This operation may not be invoked if this RTC is not already
       *   participating in the execution context. Such a call shall fail
       *   with ReturnCode_t::PRECONDITION_NOT_MET.
       *
       * - This operation may not be invoked if this RTC is Active in
       *   the indicated execution context. Otherwise, it shall fail with
       *   ReturnCode_t::PRECONDITION_NOT_MET.
       *
       * @endif
       */
  public RTC.ReturnCode_t detach_context (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("detach_context", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return detach_context (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // detach_context


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief get_context
       *
       * @section Description
       *
       * Obtain a reference to the execution context represented by the
       * given handle.
       *
       * @section Semantics
       *
       * The mapping from handle to context is specific to a particular
       * RTC instance. The given handle must have been obtained by a
       * previous call to attach_context on this RTC.
       *
       * @endif
       */
  public RTC.ExecutionContext get_context (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_context", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ExecutionContext $result = RTC.ExecutionContextHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_context (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // get_context


  /*!
       * @if jp
       * @brief get_owned_contexts
       *
       * @section Description 
       *
       * \u00fd\u00fd\u00fd\u00fd RTC \u00fd\u00fd\u00fd\u00fd\u00fdL\u00fd\u00fd\u00fd\u00fd ExecutionContext \u00fd\u00fd\u00fdX\u00fdg\u00fd\u00fd\u00fd\u00fe\u00fd\u00fd\u00fd\u00fdB
       * 
       * @else
       * @brief get_owned_contexts
       *
       * @section Description 
       *
       * This operation returns a list of all execution contexts owned
       * by this RTC.
       *
       * @endif
       */
  public RTC.ExecutionContext[] get_owned_contexts ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_owned_contexts", true);
                $in = _invoke ($out);
                RTC.ExecutionContext $result[] = RTC.ExecutionContextListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_owned_contexts (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_owned_contexts


  /*!
       * @if jp
       * @brief get_participating_contexts
       *  
       * @section Description
       *
       * \u00fd\u00fd\u00fd\u00fd RTC \u00fd\u00fd\u00fdQ\u00fd\u00fd\u00fd\u00fd\u00fd\u00fd\u00fd\u00b7\u00fd\u00c2\u00fd ExecutionContext \u00fd\u00fd\u00fdX\u00fdg\u00fd\u00fd\u00fd\u00fe\u00fd\u00fd\u00fd\u00fdB
       *
       * @section Semantics
       *
       * \u00fd\u00fd\u00fd\u00fd\u00fdX\u00fdg\u00fdJ\u00fd\u00fd\u00fd\u00fds\u00fdR\u00fd\u00fd\u00fde\u00fdL\u00fdX\u00fdg\u00fdAAattach_context \u00fd\u00fd\u00fdOo
       * \u00fd\u00fd\u00fd\u00fd\u00b2\u00fd\u0082AA\u00fd\u00fd\u00fdX\u00fdg\u00fdR\u00c9\u00fd\u00fd\u00fd\u00fd\u00fdAdetach_context \u00fd\u00fd\u00fdOo\u00fd\u00fd\u00fd\u00fd\u00b2
       * \u00fd\u0082AA\u00fd\u00fd\u00fdX\u00fdg\u00fd\u00fd\u00fd\u00fd\u00dc\u00fd\u00fd\u00fd\u00fd\u00fdB
       *
       * @else
       * @brief* get_participating_contexts
       *
       * @section Description
       *
       * This operation returns a list of all execution contexts in
       * which this RTC participates.
       *
       * @section Semantics
       *
       * Each call to attach_context causes the provided context to be
       * added to this list. Each call to detach_context causes the
       * provided context to be removed from this list.
       *
       * @endif
       */
  public RTC.ExecutionContext[] get_participating_contexts ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_participating_contexts", true);
                $in = _invoke ($out);
                RTC.ExecutionContext $result[] = RTC.ExecutionContextListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_participating_contexts (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_participating_contexts


  /*!
       * @if jp
       * ### [\u00fd\u00fdA] RTC.idl \u00fdBJ\u00fd\u00fd\u00fd\u00fd\u00fd\u00fdPIM\u00fdBJ\u00fd\u00fd\u00fd\u00fdB
       * ### PIM\u00fd\u00fd\u00fd\u00fd\u00fd\u00fd\u00fd\u00fd\u00fdB
       *
       * @brief 
       * @else
       * @brief get_context_handle
       *
       * @section Description
       * 
       * This operation returns a handle that is associated with the given
       * execution context.
       *
       * @endif
       */
  public int get_context_handle (RTC.ExecutionContext cxt)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_context_handle", true);
                RTC.ExecutionContextHelper.write ($out, cxt);
                $in = _invoke ($out);
                int $result = RTC.ExecutionContextHandle_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_context_handle (cxt        );
            } finally {
                _releaseReply ($in);
            }
  } // get_context_handle


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_initialize
       *
       * @section Description
       *
       * The RTC has been initialized and entered the Alive state.
       *
       * @section Semantics
       *
       * Any RTC-specific initialization logic should be performed here.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_initialize ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_initialize", true);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_initialize (        );
            } finally {
                _releaseReply ($in);
            }
  } // on_initialize


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_finalize
       *
       * @section Description
       *
       * The RTC is being destroyed.
       *
       * @section Semantics
       *
       * Any final RTC-specific tear-down logic should be performed here.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_finalize ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_finalize", true);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_finalize (        );
            } finally {
                _releaseReply ($in);
            }
  } // on_finalize


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_startup
       *
       * @section Description
       *
       * The given execution context, in which the RTC is participating,
       * has transitioned from Stopped to Running.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_startup (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_startup", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_startup (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_startup


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_shutdown
       *
       * @section Description
       *
       * The given execution context, in which the RTC is participating,
       * has transitioned from Running to Stopped.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_shutdown (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_shutdown", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_shutdown (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_shutdown


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_activated
       *
       * @section Description
       *
       * The RTC has been activated in the given execution context.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_activated (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_activated", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_activated (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_activated


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_deactivated
       *
       * @section Description
       *
       * The RTC has been deactivated in the given execution context.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_deactivated (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_deactivated", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_deactivated (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_deactivated


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_aborting
       *
       * @section Description
       *
       * The RTC is transitioning from the Active state to the Error
       * state in some execution context.
       *
       * @section Semantics
       *
       * This callback is invoked only a single time for time that the
       * RTC transitions into the Error state from another state. This
       * behavior is in contrast to that of on_error.  
       *
       * @endif
       */
  public RTC.ReturnCode_t on_aborting (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_aborting", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_aborting (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_aborting


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_error
       *
       * @section Description
       *
       * The RTC remains in the Error state.
       *
       * @section Semantics
       *
       * If the RTC is in the Error state relative to some execution
       * context when it would otherwise be invoked from that context
       * (according to the context\u00fdfs ExecutionKind), this callback
       * shall be invoked instead. For example,
       *
       * - If the ExecutionKind is PERIODIC, this operation shall be
       *   invoked in sorted order at the rate of the context instead of
       *   DataFlowComponentAction::on_execute and on_state_update.
       *
       * - If the ExecutionKind is EVENT_DRIVEN, this operation shall be
       *   invoked whenever FsmParticipantAction::on_action would
       *   otherwise have been invoked.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_error (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_error", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_error (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_error


  /*!
       * @if jp
       * @brief 
       * @else
       * @brief on_reset
       *
       * @section Description
       *
       * The RTC is in the Error state. An attempt is being made to
       * recover it such that it can return to the Inactive state.
       *
       * @section Semantics
       *
       * If the RTC was successfully recovered and can safely return to
       * the Inactive state, this method shall complete with
       * ReturnCode_t::OK. Any other result shall indicate that the RTC
       * should remain in the Error state.
       *
       * @endif
       */
  public RTC.ReturnCode_t on_reset (int exec_handle)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("on_reset", true);
                RTC.ExecutionContextHandle_tHelper.write ($out, exec_handle);
                $in = _invoke ($out);
                RTC.ReturnCode_t $result = RTC.ReturnCode_tHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return on_reset (exec_handle        );
            } finally {
                _releaseReply ($in);
            }
  } // on_reset

  public String get_sdo_id () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_sdo_id", true);
                $in = _invoke ($out);
                String $result = _SDOPackage.UniqueIdentifierHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_sdo_id (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_sdo_id

  public String get_sdo_type () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_sdo_type", true);
                $in = _invoke ($out);
                String $result = $in.read_string ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_sdo_type (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_sdo_type

  public _SDOPackage.DeviceProfile get_device_profile () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_device_profile", true);
                $in = _invoke ($out);
                _SDOPackage.DeviceProfile $result = _SDOPackage.DeviceProfileHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_device_profile (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_device_profile

  public _SDOPackage.ServiceProfile[] get_service_profiles () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_service_profiles", true);
                $in = _invoke ($out);
                _SDOPackage.ServiceProfile $result[] = _SDOPackage.ServiceProfileListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_service_profiles (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_service_profiles

  public _SDOPackage.ServiceProfile get_service_profile (String id) throws _SDOPackage.InvalidParameter, _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_service_profile", true);
                _SDOPackage.UniqueIdentifierHelper.write ($out, id);
                $in = _invoke ($out);
                _SDOPackage.ServiceProfile $result = _SDOPackage.ServiceProfileHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/InvalidParameter:1.0"))
                    throw _SDOPackage.InvalidParameterHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_service_profile (id        );
            } finally {
                _releaseReply ($in);
            }
  } // get_service_profile

  public _SDOPackage.SDOService get_sdo_service (String id) throws _SDOPackage.InvalidParameter, _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_sdo_service", true);
                _SDOPackage.UniqueIdentifierHelper.write ($out, id);
                $in = _invoke ($out);
                _SDOPackage.SDOService $result = _SDOPackage.SDOServiceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/InvalidParameter:1.0"))
                    throw _SDOPackage.InvalidParameterHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_sdo_service (id        );
            } finally {
                _releaseReply ($in);
            }
  } // get_sdo_service

  public _SDOPackage.Configuration get_configuration () throws _SDOPackage.InterfaceNotImplemented, _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_configuration", true);
                $in = _invoke ($out);
                _SDOPackage.Configuration $result = _SDOPackage.ConfigurationHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/InterfaceNotImplemented:1.0"))
                    throw _SDOPackage.InterfaceNotImplementedHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_configuration (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_configuration

  public _SDOPackage.Monitoring get_monitoring () throws _SDOPackage.InterfaceNotImplemented, _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_monitoring", true);
                $in = _invoke ($out);
                _SDOPackage.Monitoring $result = _SDOPackage.MonitoringHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/InterfaceNotImplemented:1.0"))
                    throw _SDOPackage.InterfaceNotImplementedHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_monitoring (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_monitoring

  public _SDOPackage.Organization[] get_organizations () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_organizations", true);
                $in = _invoke ($out);
                _SDOPackage.Organization $result[] = _SDOPackage.OrganizationListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_organizations (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_organizations

  public _SDOPackage.NameValue[] get_status_list () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_status_list", true);
                $in = _invoke ($out);
                _SDOPackage.NameValue $result[] = _SDOPackage.NVListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_status_list (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_status_list

  public org.omg.CORBA.Any get_status (String nme) throws _SDOPackage.InvalidParameter, _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_status", true);
                $out.write_string (nme);
                $in = _invoke ($out);
                org.omg.CORBA.Any $result = $in.read_any ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/InvalidParameter:1.0"))
                    throw _SDOPackage.InvalidParameterHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_status (nme        );
            } finally {
                _releaseReply ($in);
            }
  } // get_status

  public _SDOPackage.Organization[] get_owned_organizations () throws _SDOPackage.NotAvailable, _SDOPackage.InternalError
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("get_owned_organizations", true);
                $in = _invoke ($out);
                _SDOPackage.Organization $result[] = _SDOPackage.OrganizationListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:org.omg/_SDOPackage/NotAvailable:1.0"))
                    throw _SDOPackage.NotAvailableHelper.read ($in);
                else if (_id.equals ("IDL:org.omg/_SDOPackage/InternalError:1.0"))
                    throw _SDOPackage.InternalErrorHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return get_owned_organizations (        );
            } finally {
                _releaseReply ($in);
            }
  } // get_owned_organizations

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:omg.org/RTC/RTObject:1.0", 
    "IDL:omg.org/RTC/LightweightRTObject:1.0", 
    "IDL:omg.org/RTC/ComponentAction:1.0", 
    "IDL:org.omg/SDOPackage/SDO:1.0", 
    "IDL:org.omg/SDOPackage/SDOSystemElement:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _RTObjectStub
